--Hilfsfunktion fac zur Berechnung der einzelnen Listenelemente
fac :: Integer -> Integer
fac n
 | n == 0 = 1
 | otherwise = n * (fac(n-1))

--Hauptfunktion facLst, erstellt Liste der ersten n Werte der Fakultätsfunktion

facLst :: Integer -> [Integer]
facLst n
 | n < 0 = []
 | otherwise = facLst(n-1) ++ [(fac n)]

--Hauptfunktion factsL erstellt eine Liste in der umgekehrten Reihenfolge von facLst

factsL :: Integer -> [Integer]
factsL n = reverse(facLst n)

--Hauptfunktion extractNumerals, übergibt nichtleeren String mit Hilfsstring und Ergebnisliste an extractH

extractNumerals :: String -> [String]
extractNumerals s
 | s == "" = []
 | otherwise = extractH s [] []

--Hilfsfunktion extractH übrprüft, ob Char eine Ziffer ist und fügt sie dem Hilfsstring hinzu, wenn dem so
--ist. Sollte Char keine Ziffer sein, wird der nichtleere Hilfsstring an die Ergebnisliste übergeben.

extractH :: String -> String -> [String] -> [String]
extractH s h e
 | (s == []) && (h /= []) = e ++ [h]
 | s == [] = e
 | elem (head s) ['0','1','2','3','4','5','6','7','8','9'] = extractH (tail s) (h ++ [(head s)]) e
 | h == "" = extractH (tail s) [] e
 | otherwise = extractH (tail s) [] (e ++ [h])

--Hauptfunktion isPowOf2 überprüft Parameter und übergibt n mit 2^0 und 0 an checkPow2

isPowOf2 :: Int -> (Bool, Int)
isPowOf2 n
 | (((mod n 2) == 1) && n /=1) || n <= 0 = (False, -1)
 | otherwise = checkPow2 n 1 0

--Hilfsfunktion checkPow2 prüft, ob n Potenz von 2 und n == p == 2^m gilt

checkPow2 :: Int -> Int -> Int -> (Bool, Int)
checkPow2 n p m 
 | p == n = (True, m)
 | n > p = checkPow2 n (2*p) (m+1)
 | otherwise = (False, -1)

--Hauptfunktion sL2pO2 erstellt Liste der Int Werte des Ergebnistupels von isPowOf2

sL2pO2 :: [String] -> [Int]
sL2pO2 [] = []
sL2pO2 (x:xs) = [takeInt(isPowOf2(convert(x)))] ++ (sL2pO2 xs)

takeInt :: (Bool, Int) -> Int
takeInt (b, i) = i

--Die folgenden Funktionen sind aus dem ersten Übungsblatt entnommen:
--Hauptfunktion extractDigits fügt Ziffern in der vorkommenden Reihenfolge zu einem String zusammen

extractDigits :: String -> String
extractDigits s
 | s == "" = ""
 | elem (head s) ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'] = [(head s)] ++ (extractDigits (tail s))
 | otherwise = extractDigits (tail s)

--Hauptfunktion convert, übergibt den reversierten Ziffernstring an addUp

convert :: String -> Int
convert s 
 | extractDigits s == "" = 0
 | otherwise = addUp (reverse (extractDigits s)) 1

--Hilfsfunktion 1: addUp summiert die Ziffern multipliziert mit der zugehörigen Zehnerpotenz auf

addUp :: String -> Int -> Int
addUp s p
 | s == "" = 0
 | otherwise = ((digitToInt (head s))*p) + addUp (tail s) (p*10)

--Hilfsfunktion 2: digitToInt wandelt Char in Integer um

digitToInt :: Char -> Int
digitToInt c 
 | c == '1' = 1
 | c == '2' = 2
 | c == '3' = 3
 | c == '4' = 4
 | c == '5' = 5
 | c == '6' = 6
 | c == '7' = 7
 | c == '8' = 8
 | c == '9' = 9
 | otherwise = 0

curry3 :: ((a,b,c) -> d) -> a -> b -> c -> d
curry3 f a b c = f(a,b,c)

uncurry3 :: (a -> b -> c -> d) -> (a,b,c) -> d
uncurry3 f (a,b,c) = f a b c

funktion3C :: Integer -> Integer -> Integer -> Integer
funktion3C a b c 
 | c /= 0 = div (a*b) c
 | otherwise = 0

funktion3U :: (Integer, Integer, Integer) -> Integer
funktion3U (a,b,c) 
 | c /= 0 = div (a*b) c
 | otherwise = 0

curry4 :: ((a,b,c,d) -> e) -> a -> b -> c -> d -> e
curry4 f a b c d = f (a,b,c,d)

uncurry4 :: (a -> b -> c -> d -> e) -> (a,b,c,d) -> e
uncurry4 f (a,b,c,d) = f a b c d

funktion4C :: Integer -> Integer -> Integer -> Integer -> Integer
funktion4C a b c d = div (a + b + c + d) 4

funktion4U :: (Integer,Integer,Integer,Integer) -> Integer
funktion4U (a,b,c,d) = div (a + b + c + d) 4