Aufgabe4
Beispiel 1

> data Tree a = Nil | Node a (Tree a) (Tree a) deriving (Eq,Ord,Show)
> data Order = Up | Down deriving (Eq,Show)

Funktion nil zur Erzeugung eines leeren Binärbaumes mit dem Wert nil

> nil :: Tree a
> nil = Nil

Funktion isNilTree zur Überprüfung, ob Binärbaum leer

> isNilTree :: Tree a -> Bool
> isNilTree Nil = True
> isNilTree _ = False

Funktion isNodeTree zur Überprüfung, ob Binärbaum nichtleer

> isNodeTree :: Tree a -> Bool
> isNodeTree Nil = False
> isNodeTree _ = True

Funktion leftSubTree gibt nichtleeren linken Teilbaum zurück

> leftSubTree :: Tree a -> Tree a
> leftSubTree Nil = error "Empty Tree as Argument"
> leftSubTree (Node _ l _) = l

Funktion rightSubTree gibt nichtleeren rechten Teilbaum zurück

> rightSubTree :: Tree a -> Tree a
> rightSubTree Nil = error "Empty Tree as Argument"
> rightSubTree (Node _ _ r) = r

Funktion treeValue gibt die Markierung des Wurzelknoten zurück

> treeValue :: Tree a -> a
> treeValue Nil = error "Empty Tree as Argument"
> treeValue (Node v _ _) = v

Funktion isValueOf gibt True zurück (für geordneten oder nicht geordneten Baum), wenn v <- Baum

> isValueOf :: Eq a => a -> Tree a -> Bool
> isValueOf _ Nil = False
> isValueOf v (Node w l r)
>  | v == w = True
>  | otherwise = (isValueOf v l) || (isValueOf v r)

Funktion isOrderedTree überprüft, ob übergebener Binärbaum geordnet

> isOrderedTree :: Ord a => Tree a -> Bool
> isOrderedTree Nil = True
> isOrderedTree a = isOrderedTreeH a

> isOrderedTreeH :: Ord a => Tree a -> Bool
> isOrderedTreeH Nil = False
> isOrderedTreeH(Node v l r)
>  | (isNodeTree l) && (isNodeTree r) = (allsmaller l v) && (isOrderedTreeH l) && (allgreater r v) && (isOrderedTreeH r)
>  | isNodeTree l = (allsmaller l v) && (isOrderedTreeH l)
>  | isNodeTree r = (allgreater r v) && (isOrderedTreeH r)
>  | otherwise = True

allsmaller überprüft, ob alle Werte im Baum kleiner als der übergebene Wert

> allsmaller :: Ord a => Tree a -> a-> Bool
> allsmaller Nil _ = True
> allsmaller (Node w l r) v = (v > w)  && (allsmaller l v) && (allsmaller r v) 

allgreater überprüft, ob alle Werte im Baum größer als der übergebene Wert

> allgreater :: Ord a => Tree a -> a -> Bool
> allgreater Nil _ = True
> allgreater (Node w l r) v = (w > v) && (allgreater l v) && (allgreater r v)

isOrderedTree (Node 4 ((Node 5 (Node 7 Nil Nil) (Node 8 Nil Nil))) (Node 6 Nil (Node 9 Nil Nil))) -> False (nicht geordnet)
isOrderedTree ((Node "a" (Node "b" (Nil) (Nil)) (Nil))) -> False
isOrderedTree (Node 4 ((Node 2 (Node 1 Nil Nil) (Node 3 Nil Nil))) (Node 6 (Node 6 Nil Nil) (Node 9 Nil Nil))) -> False (Duplikat)
isOrderedTree (Node 4 ((Node 2 (Node 1 Nil Nil) (Node 3 Nil Nil))) (Node 6 (Node 5 Nil Nil) (Node 9 Nil Nil))) -> True
isOrderedTree (Node 4 (Node 2 Nil (Node 4 Nil Nil)) (Node 5 (Node 4 Nil Nil) (Node 7 Nil Nil))) -> False (Duplikat und nicht geordnet)
isOrderedTree (Node 2 Nil Nil) -> True
isOrderedTree (Node 2 Nil (Node 3 Nil Nil)) -> True

Funktion insert fügt in einen geordneten Baum einen Wert v in geordneter Weise hinzu, wenn dieser nicht enthalten ist. Wenn v schon enthalten, wird der übergebene Baum zurückgegeben

> insert :: Ord a => a -> Tree a -> Tree a
> insert v a 
>  | isOrderedTree a = insertH v a
>  | otherwise = error "Argument Tree not Ordered"

> insertH :: Ord a => a -> Tree a -> Tree a
> insertH v Nil = (Node v Nil Nil)
> insertH v (Node w l r)
>  | isValueOf v (Node w l r) = (Node w l r)
>  | (v < w) = (Node w (insertH v l) r)
>  | otherwise = (Node w l (insertH v r))

Funktion delete entfernt einen Wert v aus einem geordneten Baum in geordneter Weise, wenn dieser enthalten ist. Wenn v nicht enthalten, wird der übergebene Baum zurückgegeben

> delete :: Ord a => a -> Tree a -> Tree a
> delete v a
>  | isOrderedTree a = deleteH v a
>  | otherwise = error "Argument Tree not Ordered"

> deleteH :: Ord a => a -> Tree a -> Tree a
> deleteH _ Nil = Nil
> deleteH v (Node w l r)
>  | ((isValueOf v (Node w l r)) == False) = (Node w l r)
>  | v < w = (Node w (deleteH v l) r)
>  | v > w = (Node w l (deleteH v r))
>  | otherwise = replaceRoot (Node w l r)

> replaceRoot :: Ord a => Tree a -> Tree a
> replaceRoot Nil  = Nil
> replaceRoot (Node v l r) 
>  | r == Nil = l 
>  | otherwise = (Node (smallest r) l (delete (smallest r) r))

> smallest :: Ord a => Tree a -> a
> smallest Nil = error "Should not happen"
> smallest (Node v l r) 
>  | l == Nil = v
>  | otherwise = smallest l

MOFO Baum (Node 4 (Node 2 (Node 1 Nil Nil) (Node 3 Nil Nil)) (Node 6 (Node 5 Nil Nil) (Node 9 (Node 8 Nil Nil) (Node 23 (Node 19 Nil Nil) (Node 26 Nil Nil)))))
MOFO Baum 2 (Node 101 (Node 57 (Node 29 (Node 11 Nil Nil) Nil) (Node 99 (Node 62 Nil (Node 88 Nil Nil)) Nil)) (Node 151 (Node 121 Nil (Node 135 Nil Nil)) (Node 176 (Node 161 Nil Nil) (Node 199 Nil Nil))))

Funktion flatten liefert bei einem geordneten Baum eine aufsteigende (Up) bzw absteigende Liste (Down) aller im Baum enthaltenen Elemente

> flatten :: Ord a => Order -> Tree a -> [a]
> flatten o a 
>  | (isOrderedTree a) == False = error  "Argument Tree not Ordered"
>  | o == Up = flattenUp a
>  | otherwise = reverse (flattenUp a)

> flattenUp :: Tree a -> [a]
> flattenUp Nil = []
> flattenUp (Node v l r) = (flattenUp l) ++ [v] ++ (flattenUp r)

Beispiel 2
Balanciertheit von Bäumen

Funktion maxLength gibt die Länge des längsten Weges von der Wurzel zu einem Blatt zurück

> maxLength :: Tree a -> Int
> maxLength Nil = 0
> maxLength (Node _ l r) = max (1 + (maxLength l)) (1 + maxLength r)

Funktion minLength gibt die Länge des kürzesten Weges von der Wurzel zu einem Blatt zurück

> minLength :: Tree a -> Int
> minLength Nil = 0
> minLength (Node _ l r) = min (1 + (minLength l)) (1 + (minLength r))

> balancedDegree :: Tree a -> Int
> balancedDegree a = abs ((maxLength a) - (minLength a))
