--Aufgabe 5 

data Digit = Zero | One | Two
type Digits = [Digit]
data Sign = Pos | Neg -- Pos fuer Positive, Neg fuer Negative
newtype Numeral = Num (Sign,Digits)

--Funktionen aus Aufgabe3

canonize :: Numeral -> Numeral
canonize (Num (s, d))
 | d == [] = error "Invalid Argument"
 | (head d == Zero) && (tail d == []) = Num (Pos,d)
 | otherwise = Num (s, (canonizeH d))

--canonizeH nimmt Digits und entfernt solange führende Zero, bis One oder Two "führt"

canonizeH :: Digits -> Digits
canonizeH d
 | (head d == Zero) && (tail d == []) = d
 | head d == Zero = canonizeH (drop 1 d)
 | otherwise = d

--int2num zur Umwandlung von Dezimalzahlen zu Num, ruft canonize, int2numH auf
--Anmerkung: Digits für Pos/Neg Nums sind gleich, nur das Vorzeichen muss geändert werden

int2num :: Integer -> Numeral
int2num n 
 | n == 0 = Num (Pos, [Zero])
 | n < 0 = Num (Neg, (int2numH ((-1) * n) []))
 | otherwise = canonize (Num (Pos, (int2numH n [])))

--Da Sonderfall 0 schon in int2num abgedeckt, ist n == 0 Abbruchbedingung (sonst wäre der Rückgabewert ungültig)
--Wenn die Zahl durch 3 teilbar, füge vorne 0 an
--Wenn die Zahl mod 3 == 1, füge 1 vorne an
--Andernfalls füge 2 an
--Nächste Rekursion mit div n 3

int2numH :: Integer -> Digits -> Digits
int2numH n d
 | n == 0 = d
 | mod n 3 == 0 = int2numH (div n 3) (Zero : d)
 | mod n 3 == 1 = int2numH (div n 3) (One : d)
 | otherwise = int2numH (div n 3) (Two : d)

--num2int waandelt Numerale in Dezimalzahlen um, "leere" Zahlen werden nicht akzeptiert
--ruft canonize, num2intH auf

num2int :: Numeral -> Integer
num2int (Num (s,d))
 | d == [] = error "Invalid Argument"
 | s == Neg = (-1) * (num2intH d)
 | otherwise = num2intH (canonizeH d)

--Wenn letzte Stelle Zero, addiere 0 
--Wenn letzte Stelle One, addiere 1
--Wenn letzte Stelle Two, addiere 2
--"Restzahl" wird mit 3 für Stelligkeit multipliziert

num2intH :: Digits -> Integer
num2intH d
 | d == [] = 0
 | last d == Zero = (3 * (num2intH(init d))) + 0
 | last d == One = (3 * (num2intH(init d))) + 1
 | otherwise = (3 * (num2intH(init d))) + 2

--inc erhöht den Wert der Zahl um 1 (nicht den Betrag!), ruft canonizeN (damit Datentyp numeral nicht verlassen
--wird), decH, incH auf.
--Sonderfall, wenn Vorzeichen sich ändert bei inc -1
--Negative Zahlen -> Betrag verringert sich um 1
--Postivie Zahlen -> Betrag erhöht sich um 1

inc :: Numeral -> Numeral
inc (Num (s,d))
 | d == [] = error "Invalid Argument"
 | (s == Neg) && (d == [One]) = Num (Pos, [Zero])
 | d == [Zero] = Num (Pos, [One])
 | s == Pos = canonizeN(incH (canonizeN (Num (s,d))))
 | otherwise = canonizeN(decH (canonizeN (Num (s,d))))

--canonizeN wie canonize, nur innerhalb von Numeral

canonizeN :: Numeral -> Numeral
canonizeN (Num (s,d))
 | (head d == Zero) && (tail d == []) = Num (Pos,[Zero])
 | head d == Zero = canonizeN (Num(s, (drop 1 d)))
 | otherwise = Num (s,d)

--incH erhöht Betrag um 1
--Sonderfall wenn es ein Carry gibt, also letzte Stelle 2, dann muss der vordere Teil der Zahl um 1 erhöht
--werden (rekursiv)
--Sonderfall wenn Stellen der Zahl nicht ausreichen, also alle Stellen 2, dann muss ein Zero hinzugefügt werden

incH :: Numeral -> Numeral
incH (Num (s,d))
 | last d == Zero = Num (s, ((init d) ++ [One]))
 | last d == One = Num (s, ((init d) ++ [Two]))
 | (last d == Two) && ((length d == 1)) = Num (s, [One, Zero])
 | otherwise = addZero(incH (Num (s, init d)))

--addZero fügt an der letzten Stelle ein Zero hinzu

addZero :: Numeral -> Numeral
addZero (Num(s,d)) = Num(s, (d ++ [Zero]))

--decH verringert Betrag um 1
--Sonderfall, wenn es ein Carry gibt, also letzte Stelle 0, dann wird letzte Stelle zu Two und der vordere Teil
--der Zahl muss um 1 verringert werden.

decH :: Numeral -> Numeral
decH (Num (s,d))
 | last d == Two  = Num (s, ((init d) ++ [One]))
 | last d == One  = Num (s, ((init d) ++ [Zero]))
 | last d == Zero = addTwo(decH (Num (s, (init d))))

--addTwo fügt an der letzten Stelle ein Two hinzu

addTwo :: Numeral -> Numeral
addTwo (Num(s,d)) = Num(s, (d++[Two]))

--dec Verringert den Wert der Zahl um 1, ruft canonizeN, decH, incH auf
--Positiv -> Betrag verringert sich um 1
--Negativ -> Betrage erhöht sich um 1
--Sonderfall, wenn 0 dekrementiert wird (Vorzeichensprung)

dec :: Numeral -> Numeral
dec (Num (s,d))
 | d == [] = error "Invalid Argument"
 | d == [Zero] = Num (Neg, [One])
 | s == Pos = canonizeN(decH (canonizeN(Num (s,d))))
 | otherwise = canonizeN(incH (canonizeN(Num (s,d))))

--Aufgabe 3
--numAdd addiert zwei (gültige) Numerale, indem das zweite Argument (je nach Vorzeichen) verringert bzw. erhöht
--wird und das erste Argument erhöht bzw Verringert. Bricht ab, wenn ein Argument 0.
--Bsp: 5 + 3 = 6 + 2 = 7 + 1 = 8 + 0
--Bsp: 2 + (-5) = 1 + (-4) = 0 + (-3)
--ruft canonizeN, inc, dec auf

numAdd :: Numeral -> Numeral -> Numeral
numAdd (Num (s,d)) (Num (t, e))
 | (d == []) || (e == []) = error "Invalid Argument"
 | d == [Zero] = canonizeN (Num (t,e))
 | e == [Zero] = canonizeN (Num(s,d))
 | t == Pos = numAdd (inc(Num (s,d))) (dec(Num (t,e)))
 | otherwise = numAdd (dec(Num (s,d))) (inc(Num (t,e)))

--numMult übernimmt (gültige) Argumente für Multiplikation, setzt gleiche Vorzeichen auf Pos 
--ruft numMultC, canonizeN auf

numMult :: Numeral -> Numeral -> Numeral
numMult (Num (s,d)) (Num (t, e)) 
 | (d == []) || (e == []) = error "Invalid Argument"
 | s == t = numMultC (canonizeN(Num (Pos, d))) (canonizeN(Num (Pos, e)))
 | otherwise = numMultC (canonizeN(Num (s,d))) (canonizeN(Num (t, e)))

--numMultC multipliziert nach dem Schema
--Bsp: 5 * 5 = 5 + (5 * 4) = 5 + 5 + (5 * 3) usw.
--Bsp: 3 * (-4) = -3 + (3 * (-3)) = (-3) + (-3) + (3 * (-2)) usw.

numMultC :: Numeral -> Numeral -> Numeral
numMultC (Num (s,d)) (Num (t, e)) 
 | (d == [Zero]) || (e == [Zero]) = Num(Pos,[Zero])
 | (s == t) && (e == [One]) = canonizeN((Num(s,d)))
 | (s == t) && (d == [One]) = canonizeN((Num(t,e)))
 | (e == [One]) = canonizeN(Num(Neg, d))
 | (d == [One]) = canonizeN(Num(Neg, e))
 | (s == t) = numAdd (Num (s,d)) (numMult (Num (s,d)) (dec((Num (t, e)))))
 | s == Pos = numAdd (Num (Neg, d)) (numMult (Num (s,d)) (inc((Num (t, e)))))
 | otherwise = numMultC (Num (t,e)) (Num (s,d))
--Implementierung von Eq für Sign, Digit und Numeral

instance Eq Sign where
	(==) Pos Pos = True
	(==) Neg Neg = True
	(==) _ _ = False

instance Eq Digit where
	(==) Zero Zero = True
	(==) One One = True
	(==) Two Two = True
	(==) _ _ = False

instance Eq Numeral where
	(==) (Num (s, [Zero])) (Num (t,[Zero])) = True
 	(==) (Num (s,d)) (Num (t,e)) =
 		(s == t) && ((canonizeH d) == (canonizeH e))
 	(==) _ _ = False

--Implementierung von Show für Sign, Digit, Numeral

instance Show Sign where
	show Pos = "+"
	show Neg = "-"

instance Show Digit where
	show Zero = "0"
	show One = "1"
	show Two = "2"

instance Show Numeral where
	show (Num(s,d)) = (show s) ++ (toOne(digits)) where
		digits = (canonizeH d)
		toOne [] = error "Invalid Argument"
		toOne (x:[]) = show x
		toOne (x:xs) = (show x) ++ (toOne xs)

--Implementierung von Ord für Digit und Numeral

instance Ord Digit where
	compare Zero Zero = EQ
	compare One One = EQ
	compare Two Two = EQ
	compare Zero _ = LT
	compare One Zero = GT
	compare One Two = LT
	compare Two _ = GT

instance Ord Numeral where
	compare a b = comp (canonize a) (canonize b) where
		comp (Num (s,[Zero])) (Num (t,[Zero])) = EQ
		comp (Num (Pos,d)) (Num (Neg,e)) = GT
		comp (Num (Neg,d)) (Num (Pos,e)) = LT
		comp (Num (Pos,d)) (Num (Pos,e)) = digComp d e where
			digComp x@(a:as) y@(b:bs)
			 | x == y = EQ
			 | (length x) > (length y) = GT
			 | (length y) > (length x) = LT
			 | (a > b) = GT
			 | (a < b) = LT
			 | otherwise = digComp as bs
		comp (Num (Neg,d)) (Num (Neg,e)) = comp (Num (Pos,e)) (Num (Pos,d))

--Implementierung von Num für Numeral

instance Num Numeral where
	signum (Num (s,d)) = sig (Num(s,(canonizeH d))) where
		sig(Num(_,[Zero])) = (Num (Pos,[Zero]))
		sig(Num(s, _)) = (Num (s, [One]))
	negate (Num (s,d)) = Num((inv s),d) where
		inv Pos = Neg
		inv Neg = Pos
	abs (Num (s,d)) = (Num (Pos, d))
	fromInteger n = int2num n
	(*) a b = numMult a b
	(+) a b = numAdd a b
	(-) a b = numAdd a (inv b) where
		inv (Num (Pos,d)) = (Num (Neg, d))
		inv (Num (Neg, d)) = (Num (Pos,d))
