{- Aufgabenblatt 8 Version 1 -}
--Aufgabe 1: Schickeria und Seitenblicke
--Notwendige Definitionen

data GeladenerGast = A | B | C | D | E | F | G | H | I | J | K  | L | M | N | O | P | Q | R | S | T deriving (Eq,Ord,Enum,Show)
type Schickeria = [GeladenerGast]                     
type Adabeis    = [GeladenerGast]                     
type Nidabeis   = [GeladenerGast]                     
type NimmtTeil  = GeladenerGast -> Bool                    --Total definiert
type Kennt      = GeladenerGast -> GeladenerGast -> Bool   --Total definiert

guestList = [A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T]

notNidabeis :: NimmtTeil -> Kennt -> [GeladenerGast]
notNidabeis f g = notNidabeis' guestList (nidabeis f g) where
	notNidabeis' [] _ = []
	notNidabeis' l [] = l
	notNidabeis' (l:ls) n
	 | elem l n = notNidabeis' ls n
	 | otherwise = l:(notNidabeis' ls n)

knownbyAll :: GeladenerGast -> NimmtTeil -> Kennt -> Bool
knownbyAll s f g = knownbyAll' s (notNidabeis f g) g where
	knownbyAll' _ [] _ = True
	knownbyAll' s (x:xs) g 
	 | g x s = knownbyAll' s xs g
	 | otherwise = False

knownbyAllList :: NimmtTeil -> Kennt -> [GeladenerGast]
knownbyAllList f g = knownbyAllList' f g (notNidabeis f g) 

knownbyAllList' :: NimmtTeil -> Kennt -> [GeladenerGast] -> [GeladenerGast]
knownbyAllList' _ _ [] = []
knownbyAllList' f g (x:xs)
 | knownbyAll x f g = x: (knownbyAllList' f g xs)
 | otherwise = knownbyAllList' f g xs


notKnownbyAllList :: NimmtTeil -> Kennt -> [GeladenerGast]
notKnownbyAllList f g = notKnownbyAllList' (notNidabeis f g) f g where
	notKnownbyAllList' [] f g = []
	notKnownbyAllList' (x:xs) f g = if elem x (knownbyAllList f g) then notKnownbyAllList' xs f g else x:(notKnownbyAllList' xs f g)

istSchickeriaEvent :: NimmtTeil -> Kennt -> Bool
istSchickeriaEvent f g = part (schickeria f g) f where
	part [] f = False
	part (x:xs) f = (f x) || (part xs f)

istSuperSchick :: NimmtTeil -> Kennt -> Bool
istSuperSchick f g = (istSchickeriaEvent f g) && (not (part (adabeis f g) f)) where
	part [] f = False
	part (x:xs) f = (f x) || (part xs f)

istVollProllig :: NimmtTeil -> Kennt -> Bool
istVollProllig f g = not (istSchickeriaEvent f g)

schickeria :: NimmtTeil -> Kennt -> Schickeria
schickeria f g = [s | s <- guestList, not (elem s $ nidabeis f g), elem s (knownbyAllList f g), knowsNo s (notKnownbyAllList f g) g]

knowsNo :: GeladenerGast -> [GeladenerGast] -> Kennt -> Bool
knowsNo s [] g = True
knowsNo s (x:xs) g
 | g s x = False
 | otherwise = knowsNo s xs g	

adabeis :: NimmtTeil -> Kennt -> Adabeis
adabeis f g = [a | a <- guestList, not (elem a $ nidabeis f g), knowsAll a (schickeria f g) g, notKnownby a (schickeria f g) g] where
	knowsAll a [] g = True
	knowsAll a (x:xs) g
	 | g a x = knowsAll a xs g
	 | otherwise = False
	notKnownby a [] g = True
	notKnownby a (x:xs) g 
	 | g x a = False
	 | otherwise = notKnownby a xs g

nidabeis   :: NimmtTeil -> Kennt -> Nidabeis
nidabeis f g = [n | n <- guestList, not (f n)]

--Beispiel 2: Programmieren mit Strömen
--Definition des Stroms s nat- Zahlen
--Die Elemente von s sind echt anwachsend
--s beginnt mit der Zahl 1.
--Wenn s die Zahl n enthaelt, so enthaelt s auch die Zahlen 2n, 3n und 5n
--s enthält keine anderen Zahlen

--s beginnt mit diesen Festlegungen mit den Zahlen 1,2,3,4,5,6,8,9,10,12,..
stream :: [Integer]
stream = 1 : (merge (map (*5) stream) $ merge (map (*2) stream) (map(*3) stream)) where
	merge l1@(x:xs) l2@(y:ys)
	 | x < y = x: merge xs l2
	 | x == y = merge xs l2
	 | otherwise = y : merge l1 ys

--Beispiel 3 
--Notwendige Definitionen
type Quadrupel = (Integer,Integer,Integer,Integer)

--Angewendet auf eine nat. Zahl n >=1 gibt die Funktion in lexikographisch aufsteigender Ordnung den (Anfangs-)
--Strom der Quadrupel (a,b,c,d) über den nat. Zahlen bestimmt mit a^3+b^3=c^3+d^3 sowie 1<=a,b,c,d<=n und 
--a <= b, a < c, c <= d. Ist n <= 0, wird die leere Liste zurückgegeben
--Implementierung von quadrupel mit global sichtbaren Funktionen gen und fil
quadrupel :: Integer -> [Quadrupel]
quadrupel n
 | n <= 0 = []
 | otherwise = (fil.gen) n

--Generiert den (Anfangs-) Strom der Quadrupel mit 1 <= a,b,c,d <= n und a <= b, a < c, c <= d
gen :: Integer -> [Quadrupel]
gen n 
 | n <= 0 = []
 | otherwise = [(a,b,c,d) | a <- [1..n], b <- [1..n], c <- [1..n], d <- [1..n], a <= b, a < c, c <= d] where
 	first [] = []
 	first ((a,b,c,d):xs) = (second.first) [(a1,b1,c1,d1) | (a1,b1,c1,d1) <- xs, a1 <= a] ++ [(a,b,c,d)] ++ (second.first) [(a2,b2,c2,d2) | (a2,b2,c2,d2) <- xs, a2 > a]
 	second [] = []
 	second ((a,b,c,d):xs) = (third.second) [(a1,b1,c1,d1) | (a1,b1,c1,d1) <- xs, b1 <= b] ++ [(a,b,c,d)] ++ (third.second) [(a2,b2,c2,d2) | (a2,b2,c2,d2) <- xs, b2 > b]
 	third [] = []
 	third ((a,b,c,d):xs) = (fourth.third) [(a1,b1,c1,d1) | (a1,b1,c1,d1) <- xs, c1 <= c] ++ [(a,b,c,d)] ++ (fourth.third) [(a2,b2,c2,d2) | (a2,b2,c2,d2) <- xs, c2 > c]
 	fourth [] = []
 	fourth ((a,b,c,d):xs) = fourth [(a1,b1,c1,d1) | (a1,b1,c1,d1) <- xs, d1 <= d] ++ [(a,b,c,d)] ++ fourth[(a2,b2,c2,d2) | (a2,b2,c2,d2) <- xs, d2 > d]

--Entfernt jene Quadrupel aus einer Liste, welche die Bedingung a^3+b^3=c^3+d^3 nicht erfüllen
fil :: [Quadrupel] -> [Quadrupel]
fil [] = []
fil ((a,b,c,d):xs) 
 | a*a*a + b*b*b == c*c*c + d*d*d = (a,b,c,d) : (fil xs)
 | otherwise = fil xs

--Aufgerufen mit einer ganzen Zahl Z gibt die Funktion den Wert an der Stelle |Z| zurück
sel :: Int -> [Quadrupel] -> Quadrupel
sel n l
 | n < 0 = sel ((-1)*n) l
 | otherwise = l !! n

